> ## Documentation Index
> Fetch the complete documentation index at: https://www.klavis.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create

> Creates an instance id for a self-hosted MCP server,
validating the request with an API key and user details.
The main purpose of this endpoint is to create an instance id for a self-hosted MCP server.
The instance id is used to identify and store the auth metadata in the database.
Returns the existing instance id if it already exists for the user.



## OpenAPI

````yaml post /mcp-server/self-hosted/instance/create
openapi: 3.1.0
info:
  title: Klavis AI (https://www.klavis.ai)
  description: Klavis AI - Open Source MCP Integrations for AI Applications
  version: 0.1.0
servers:
  - url: https://api.klavis.ai
    description: US Production server
  - url: https://api.eu.klavis.ai
    description: EU Production server
security: []
paths:
  /mcp-server/self-hosted/instance/create:
    post:
      tags:
        - mcp-server
      summary: Create
      description: >-
        Creates an instance id for a self-hosted MCP server,

        validating the request with an API key and user details.

        The main purpose of this endpoint is to create an instance id for a
        self-hosted MCP server.

        The instance id is used to identify and store the auth metadata in the
        database.

        Returns the existing instance id if it already exists for the user.
      operationId: createSelfHostedServerInstance
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateSelfHostedServerRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateSelfHostedServerResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    CreateSelfHostedServerRequest:
      properties:
        serverName:
          $ref: '#/components/schemas/McpServerName'
          description: >-
            The name of the target MCP server. Case-insensitive (e.g., 'google
            calendar', 'GOOGLE_CALENDAR', 'Google Calendar' are all valid).
        userId:
          type: string
          minLength: 1
          title: Userid
          description: >-
            The unique identifier for the user. The server instance along with
            the all the authentication data will belong to that specific user
            only. It can be a UUID from the database, a unique email address
            from the user, etc.
      type: object
      required:
        - serverName
        - userId
      title: CreateSelfHostedServerRequest
    CreateSelfHostedServerResponse:
      properties:
        instanceId:
          type: string
          title: Instanceid
          description: >-
            The unique identifier for this specific server connection
            integration instance.
        oauthUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Oauthurl
          description: >-
            The OAuth authorization URL for the specified server, if OAuth is
            configured.
      type: object
      required:
        - instanceId
      title: CreateSelfHostedServerResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    McpServerName:
      type: string
      enum:
        - Affinity
        - Airtable
        - Amplitude
        - Asana
        - Attio
        - Box
        - Brave Search
        - Cal.com
        - Canva
        - ClickUp
        - Close
        - Cloudflare
        - Coinbase
        - Confluence
        - Dialpad
        - Discord
        - Doc2markdown
        - DocuSign
        - Dropbox
        - ElevenLabs
        - Exa
        - Fathom
        - Fetch URL
        - Figma
        - Fireflies
        - Firecrawl Deep Research
        - Firecrawl Web Search
        - Freshdesk
        - GitHub
        - GitLab
        - Gmail
        - Gong
        - Google Calendar
        - Google Docs
        - Google Drive
        - Google Jobs
        - Google Sheets
        - Google Forms
        - Google Cloud
        - GoogleWorkspaceAtlas
        - Hacker News
        - Heygen
        - HubSpot
        - Intercom
        - Jira
        - Klaviyo
        - Klavis ReportGen
        - Linear
        - LinkedIn
        - Markdown2doc
        - Mem0
        - Microsoft Teams
        - Mixpanel
        - Monday
        - Moneybird
        - Motion
        - Notion
        - OneDrive
        - Openrouter
        - Outlook Mail
        - Outlook Calendar
        - PagerDuty
        - Pipedrive
        - Plai
        - Postgres
        - PostHog
        - Postman
        - QuickBooks
        - Resend
        - Salesforce
        - SendGrid
        - Shopify
        - Slack
        - Snowflake
        - Stripe
        - Supabase
        - Tavily
        - Vercel
        - WhatsApp
        - WordPress
        - YouTube
        - Zendesk
        - ServiceNow
        - PayPal
        - Sentry
        - Netlify
        - Hugging Face
        - Square
        - Clockwise
        - Jotform
        - Honeycomb
        - Zoho Mail
        - Sharesight
        - Weights and Biases
        - Instagram
        - MongoDB
      title: McpServerName
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      description: Your Klavis AI API key.
      scheme: bearer
      x-fern-bearer:
        name: api_key

````